<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row mb-3">
          <label class="col-sm-2 col-form-label">Kode Proyek</label>
          <div class="col-sm-10">
            <b-form-select v-model="code" class="mb-3">
              <b-form-select-option
                v-for="proj in this.$store.getters.getterProjectChange"
                v-bind:key="proj.code"
                :value="proj.code"
              >
                {{ proj.code + " - " + proj.nickname }}
              </b-form-select-option>
            </b-form-select>
          </div>
        </div>

        <div class="row mb-3 mt-5">
          <label class="col-sm-2 col-form-label">Nomor CR</label>
          <div class="col-sm-10">
            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Nomor Cr"
              v-model="cr_number"
            ></b-form-input>
          </div>
        </div>

        <div class="row mb-3 mt-5">
          <label class="col-sm-2 col-form-label">Title</label>
          <div class="col-sm-10">
            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Title"
              v-model="title"
            ></b-form-input>
          </div>
        </div>

        <div class="row mb-3 mt-5">
          <label class="col-sm-2 col-form-label">Date</label>
          <div class="col-sm-10">
            <b-form-datepicker
              id="example-datepicker"
              v-model="date"
              class="mb-2 w-25"
            ></b-form-datepicker>
          </div>
        </div>

        <div class="d-flex justify-content-end">
          <button class="btn btn-primary btn-md" @click.prevent="save">
            <div
              class="text-center"
              v-bind:class="{
                'd-none': isLoading
              }"
            >
              <b-spinner
                style="width: 1rem; height: 1rem;"
                variant="light"
                label="Spinning"
              ></b-spinner>
            </div>
            <div
              class="text-center"
              v-bind:class="{
                'd-none': textButton
              }"
            >
              Simpan
            </div>
          </button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import {
  GET_PROJECT_CHANGE,
  POST_CHANGE_MANAGEMENT
} from "@/core/services/store/change-management.module";

export default {
  name: "change-management",
  data() {
    return {
      cr_number: "",
      title: "",
      code: "",
      date: "",
      textButton: false,
      isLoading: true
    };
  },
  methods: {
    async save() {
      var cr = this.cr_number;
      var title = this.title;
      var code = this.code;
      var date = this.date;

      var split = date.split("-");
      var fixDate = split[2] + "-" + split[1] + "-" + split[0];

      var send = {
        project: {
          code: code
        },
        cr_number: cr,
        title: title,
        date: fixDate
      };

      this.textButton = true;
      this.isLoading = false;
      await this.$store.dispatch(POST_CHANGE_MANAGEMENT, send);
      var result = this.$store.getters.getterResultSaveChange;
      console.log("result view", result);
      if (result.id == null) {
        this.$bvToast.toast(result.msg, {
          title: "Warning",
          variant: "danger",
          solid: true
        });
      } else {
        this.$bvToast.toast("Berhasil simpan data", {
          title: "Success",
          variant: "success",
          solid: true
        });

        var url = "/project/change/management/" + result.id + "/detail";
        this.$router.push(url);
      }
      this.textButton = false;
      this.isLoading = true;
    }
  },
  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Change Management" }]);

    this.$store.dispatch(GET_PROJECT_CHANGE);
  }
};
</script>

<style></style>
